'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _phantom = require('phantom');

var _phantom2 = _interopRequireDefault(_phantom);

var _explorer = require('./explorer');

var _explorer2 = _interopRequireDefault(_explorer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @private
 * @param {Clairvoyance} _this -
 * @return {Promise} -
 */
function _createPhantom(_this) {
  return new Promise(function (resolve) {
    _phantom2.default.create().then(function (ph) {
      _this.ph = ph;
      resolve();
    });
  });
}

/**
 * @private
 * @param {Clairvoyance} _this -
 * @return {Promise} -
 */
function _findCssFiles(_this) {
  return new Promise(function (resolve) {
    _this.cssFiles = _explorer2.default.findCssFiles(_this.css);
    Promise.all(_this.cssFiles.map(function (css) {
      return css.fetch();
    })).then(resolve);
  });
}

/**
 * @private
 * @param {Clairvoyance} _this -
 * @return {Promise} -
 */
function _findHtmlFiles(_this) {
  return new Promise(function (resolve) {
    _this.htmlFiles = _explorer2.default.findHtmlFiles(_this.html);
    resolve();
  });
}

/**
 * Set up clairvoyance with `options`.
 * @param {Object} options -
 */

var Clairvoyance = function () {
  function Clairvoyance(options) {
    _classCallCheck(this, Clairvoyance);

    this.css = options.css;
    this.html = options.html;
    this.reporters = options.reporters || [];
    this.result = {};
  }

  _createClass(Clairvoyance, [{
    key: 'run',
    value: function run(cb) {
      var _this2 = this;

      if (cb) {
        this.reporters.push(cb);
      }

      Promise.all([_createPhantom(this), _findCssFiles(this), _findHtmlFiles(this)]).then(function () {
        var tasks = [];

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = _this2.htmlFiles[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var html = _step.value;
            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {
              for (var _iterator4 = _this2.cssFiles[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                var css = _step4.value;

                tasks.push(html.findCss(_this2.ph, css));
              }
            } catch (err) {
              _didIteratorError4 = true;
              _iteratorError4 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion4 && _iterator4.return) {
                  _iterator4.return();
                }
              } finally {
                if (_didIteratorError4) {
                  throw _iteratorError4;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        Promise.all(tasks).then(function () {
          _this2.ph.exit();

          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = _this2.cssFiles[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var css = _step2.value;

              _this2.result[css.path] = css.result;
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }

          var _iteratorNormalCompletion3 = true;
          var _didIteratorError3 = false;
          var _iteratorError3 = undefined;

          try {
            for (var _iterator3 = _this2.reporters[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
              var reporter = _step3.value;

              reporter(_this2.result);
            }
          } catch (err) {
            _didIteratorError3 = true;
            _iteratorError3 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion3 && _iterator3.return) {
                _iterator3.return();
              }
            } finally {
              if (_didIteratorError3) {
                throw _iteratorError3;
              }
            }
          }
        });
      });
    }
  }]);

  return Clairvoyance;
}();

exports = module.exports = Clairvoyance;
//# sourceMappingURL=../maps/clairvoyance.js.map
