'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _css = require('css');

var _css2 = _interopRequireDefault(_css);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Initialize a new CSS file with the given `dir`.
 * @constructor
 * @param {String} dir - a file path
 */

var CssFile = function () {
  function CssFile(dir) {
    _classCallCheck(this, CssFile);

    this.path = _path2.default.resolve(dir);
  }

  _createClass(CssFile, [{
    key: 'mark',
    value: function mark(val, start, end) {
      for (var i = start - 1; i < end; i++) {
        this.result[i] += val;
      }
    }
  }, {
    key: 'fetch',
    value: function fetch() {
      var _this = this;

      return new Promise(function (resolve) {
        _fs2.default.readFile(_this.path, function (_, data) {
          _this._initByContent(data.toString());
          resolve();
        });
      });
    }
  }, {
    key: '_initByContent',
    value: function _initByContent(content) {
      var size = content.match(/\n/g).length;
      this.css = _css2.default.parse(content);
      this.rules = this.css.stylesheet.rules;
      this.result = new Array(size);
      for (var i = 0; i < size; i++) {
        this.result[i] = null;
      }
    }
  }]);

  return CssFile;
}();

exports.default = CssFile;
//# sourceMappingURL=../maps/cssfile.js.map
