'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Initialize a new HTML file with the given `path`.
 * @constructor
 * @param {String} path - a file path
 */

var HtmlFile = function () {
  function HtmlFile(path) {
    _classCallCheck(this, HtmlFile);

    this.path = path;
  }

  _createClass(HtmlFile, [{
    key: 'querySelectorAll',
    value: function querySelectorAll(ph, style, cb) {
      var _this = this;

      return new Promise(function (resolve) {
        ph.createPage().then(function (page) {
          page.open(_this.path).then(function () {
            var func = 'function() { return document.querySelectorAll("' + style + '"); }';
            page.evaluateJavaScript(func).then(function (value) {
              cb(value);
              resolve();
            });
          });
        });
      });
    }
  }, {
    key: 'findCss',
    value: function findCss(ph, css) {
      var _this2 = this;

      var tasks = [];

      css.rules.forEach(function (rule) {
        if (rule.type !== 'rule') {
          return;
        }

        var style = rule.selectors.toString();
        var task = _this2.querySelectorAll(ph, style, function (value) {
          css.mark(value.length, rule.position.start.line, rule.position.end.line);
        });
        tasks.push(task);
      });

      return new Promise(function (resolve) {
        return Promise.all(tasks).then(resolve);
      });
    }
  }]);

  return HtmlFile;
}();

exports.default = HtmlFile;
//# sourceMappingURL=../maps/htmlfile.js.map
